%-- loading data --

load('digits.mat');
X = digits';
[nrDims, nrPoints] = size(X);

%>> -- Part 1 -- << 
disp('starting part 1 (press enter)')
pause;

%digits contains 1000 images of the digits 0-9
%(100 of each)

figure(1);
clf;
% get familiar with the data set by plotting some different numbers:
% modify some numbers below.
%-------------------
DisplayI(1);
disp('press enter');
pause;
DisplayI(101)
disp('press enter');
pause;
%-------------------
% when you have an idea how the numbers look remove the code between the
% lines.

% In order to get a better overview, we want to plot many numbers in 
% the same plot. finish the implementation of DisplayDigitArray:
DisplayDigitArray()

% this saves the figure - submit if with your report!
print('PCAfig1.png', '-dpng');


%>> -- End Part 1 -- << 

%-- performing PCA (explanation: week 5) --
mean_X = mean(X, 2);   %<- take mean over the data points
X = X - repmat(mean_X, 1, nrPoints); %<-make zero mean
% calculate eigenvectors and eigenvalues of the covariance matrix
A = (1.0/nrPoints) .* (X * X');       %<- the empirical covariance matrix
[EigenVectors, EigenValueMatrix] = eig(A);  %<- the eigen computation
EigenValues = diag(EigenValueMatrix);      %<- the eigenvalues extracted from the diagonal - not needed
% order by largest eigenvalue
EigenValues = EigenValues(end:-1:1);
EigenVectors = EigenVectors(:,end:-1:1); %<- this puts the last column (=eigenvector) first

%-- only keep the first k eigenvalues --
k = 50;
EVals = EigenValues(1:k);
U = EigenVectors(:, 1:k);


%>> -- Part 2 -- << 
%% --Having a look at the first couple of directions of principal components--
disp('starting part 2 (press enter)')
pause;
figure(2);
clf;
rows = 3;
cols = 4;
TODO
print('PCAfig2.png', '-dpng');


% Compute the (k x nrPoints) matrix Z of compressed coordinates.
% Hint: to compute compressed coordinates of i:
%     z_i = U' * X(:, i) * U'  % <- row vector
%
Z = TODO

%>> -- End Part 2 -- << 


%>> -- Part 3 -- << 
%% --Investigation of the two first principal components themselves--
disp('starting part 3 (press enter)')
pause;

figure(3);
clf;

subplot(2,2,[1:2])
%Z_i is the i-th principle component of the data
Z_1 = TODO
Z_2 = TODO
scatter(Z_1, Z_2);
hold on;

%draw a random data point index:
index = ceil(rand*nrPoints);
z_index = [Z_1(index); Z_2(index)];
plot(z_index(1), z_index(2), 'rx',  'MarkerSize', 20);

% Find the other image that is nearest to z_index, put its index in 
% 'nearest_index'.
nearest_index = TODO

z_neighbor = [Z_1(nearest_index); Z_2(nearest_index)];
plot(z_neighbor(1), z_neighbor(2), 'rx',  'MarkerSize', 20);
subplot(2,2,3)
DisplayDigit(X(:, index));
subplot(2,2,4)
DisplayDigit(X(:, nearest_index));
%save the figure:
print('PCAfig3.png', '-dpng');






%>> -- Part 4 -- << 
%% --Compression and Reconstruction using PCA--
disp('starting part 4 (press enter)')
pause;
figure(4);
clf;

k=1;
rows = 5;
cols = 4; %<- code below depends on an even number of columns!
for r = [1:rows]
    for c = [1:cols]
        subplot(rows, cols, k);
        if mod(c,2)==1
            i = ceil(rand * nrPoints);
            DisplayDigit(X(:, i));
        else
            %compute reconstruction of data point i
            reconstruct_i =  TODO
            DisplayDigit(reconstruct_i);
        end
        k=k+1;
    end
end
print('PCAfig4.png', '-dpng');
